''
'' cog storage - command handler
''
''        Author: Marko Lukat
'' Last modified: 2011/02/20
''       Version: 0.1
''
'' long[par][0]: cog startup:        !Z =    32 -> zero (ready)
''               transaction: insn:addr = 16:16 -> zero (transaction done)
'' long[par][1]: unused
'' long[par][2]: unused
'' long[par][3]: unused
''
OBJ
  system: "core.con.system"
  
PUB null
'' This is not a top level object.

PUB init(ID, storage_setup)

  return system.launch(ID, @storage, storage_setup)

DAT             org     0                       ' cog binary header

header_2048     long    system#ID_2             ' magic number for a cog binary
                word    header_size             ' header size
                word    %00000000_00000000      ' flags
                word    0, 0                    ' start register, register count

header_size     fit     16
                
CON
  CMD_BGET = $083C0000                          ' wrlong 0, 0
  CMD_BPUT = $08BC0000                          ' rdlong 0, 0
  
DAT             org     0                       ' cog storage command handler

storage         mov     vscl, #14               ' |
loop            mov     $1F0, payload           ' |
                add     loop, incr              ' |
                djnz    vscl, #loop             ' transfer command handler to SPR
                jmp     #frqb                   ' storage active

incr            long    |< 9 | 1                ' dst++/src++

payload         org     $1F0

                rdlong  $1F7, par wz            ' $1F0  get command (insn:addr = 16:16)
        if_z    jmp     #$-1                    ' $1F1

                mov     $1FF, $1F7              ' $1F2  copy hub address
                movd    $1F7, #0                ' $1F3  cog location
                movs    $1F7, #$1FF             ' $1F4  hub location
                mov     $1FE, #$1F0             ' $1F5

                nop                             ' $1F6  dira (stay clear)

                nop                             ' $1F7  rdlong/wrlong 0-0, $1FF
                add     $-1, $1FD               ' $1F8  advance cog address
                add     $1FF, #4                ' $1F9  advance hub address
                djnz    $1FE, #$-3              ' $1FA

                wrlong  dira, par               ' $1FB  end of transfer
                jmp     #$1F0                   ' $1FC  next transaction

                long    $200                    ' $1FD  dst++
                                                ' $1FE  long count
                                                ' $1FF  hub addr

                fit     $200
                
DAT