''
'' cog storage - demo
''
''        Author: Marko Lukat
'' Last modified: 2011/02/20
''       Version: 0.1
''
CON
  _clkmode = client#_clkmode
  _xinfreq = client#_xinfreq
  
OBJ
  client: "core.con.client.demoboard"
  helper: "cog.storage.2048"
  
CON
  lcnt = $1F0                                           ' max storage size

VAR
  long  storage[lcnt]                                   ' transfer buffer
  
PUB selftest | n, command

  command := TRUE
  helper.init(-1, @command)                             ' start command handler
  repeat while command                                  ' ... active

  repeat
    vscl := frqa                                        ' remember current seed
    repeat n from 0 to constant(lcnt - 1)               ' |
      storage[n] := ?frqa                               ' pseudo-random payload

    command := helper#CMD_BPUT | @storage{0}            ' hub-to-cog
    repeat while command                                ' transfer done

    longfill(@storage{0}, 0, lcnt)                      ' clear payload (?m <> 0)

    command := helper#CMD_BGET | @storage{0}            ' cog-to-hub
    repeat while command                                ' transfer done

    dira[16..23] |= outa[16..23] := validate            ' validate read back data

PRI validate | n

  repeat n from 0 to constant(lcnt - 1)
    if storage[n] <> ?vscl
      abort

  return sequence[frqb++ & 15]

DAT                                                     ' LED sequence

sequence        byte    1, 2, 4, 8, 16, 32, 64, 128
                byte    128, 64, 32, 16, 8, 4, 2, 1

DAT